#include <fstream>
#include <iostream>
#include "AneuMeshLoader.h"
#include "Exceptions.h"

void AneuMeshLoader::LoadMesh(const std::string& filename) {
  std::ifstream file(filename);
  if (!file) {
    throw NoFileFoundException(filename);
  } else std::cout << "File \"" << filename << "\" was opened successfully." << std::endl;

	int amount, dimension, temp_id;
	double temp_coord;
	file >> amount >> dimension;
	for (int i = 1; i <= amount; i++) {
		Node temp_node;
		temp_node.id = i;
		for (int j = 1; j <= dimension; j++) {
			file >> temp_coord;
			temp_node.coord.push_back(temp_coord);
		}
		temp_node.top = true;
		nodes.push_back(std::move(temp_node));
	}

	file >> amount >> dimension;
	for (int i = 1; i <= amount; i++) {
		FiniteElement temp_element;
		temp_element.element_id = i;
		file >> temp_element.material_id;
		for (int j = 1; j <= dimension; j++) {
			file >> temp_id;
			temp_element.nodes_id.push_back(temp_id);
		}
		elements.push_back(std::move(temp_element));
	}

	file >> amount >> dimension;
	for (int i = 1; i <= amount; i++) {
		BoundaryFiniteElement temp_surface;
		temp_surface.element_id = i;
		file >> temp_surface.border_id;
		for (int j = 1; j <= dimension; j++) {
			file >> temp_id;
			temp_surface.nodes_id.push_back(temp_id);
		}
		boundary.push_back(std::move(temp_surface));
	}

  file.close();
  std::cout << "All data was loaded, closing the file..." << std::endl << std::endl;
}