#include "AneuMeshLoader.h"
#include <iostream>
#include <ranges>
#include <fstream>
#include <iterator>
#include <algorithm>

//!!! Задание на защиту (не удалять!)
//!!! Реализовать на основе std::ranges 
//!!! 1. Сформировать контейнер всех узлов.
//!!! 2. С помощью потокового итератора вывести первые 10 ID узлов,
//!!!    которые лежат между двух сфер с общим центром и радиусами R1 и R2.

void Protection_task(MeshLoader& myLoader) {
	auto ContainerNodes = myLoader.Get_Nodes();
	double x, y, z;
	int R1, R2;

	std::cout << "Enter the coordinates of the center of the spheres: " << std::endl;
	std::cout << "\tx: ";
	std::cin >> x;
	std::cout << "\ty: ";
	std::cin >> y;
	std::cout << "\tz: ";
	std::cin >> z;
	std::cout << "Enter the radius of the spheres: " << std::endl;
	std::cout << "\t1: ";
	std::cin >> R1;
	std::cout << "\t2: ";
	std::cin >> R2;

	if (R2 > R1) {
		int elem = R2;
		R2 = R1;
		R1 = elem;
	}

	auto alg = [&](const auto& elem) { //!!!! Почему нет const +
		double elem_x = elem.coord.at(0),
		elem_y = elem.coord.at(1),
		elem_z = elem.coord.at(2);

		//++a; //!!! Есть ranges::views::take Что за счетчики вы вводите? +


		return ((elem_x - x) * (elem_x - x) + (elem_y - y) * (elem_y - y) + (elem_z - z) * (elem_z - z) > R2 * R2 &&
						(elem_x - x) * (elem_x - x) + (elem_y - y) * (elem_y - y) + (elem_z - z) * (elem_z - z) < R1 * R1);
	};
	
	auto result = ContainerNodes | std::ranges::views::filter(alg) | std::ranges::views::take(10);
	
	std::ranges::copy(result, std::ostream_iterator<Node>(std::cout, "\n"));
}

int main() {
	MeshLoader* myLoader = new AneuMeshLoader;
	std::string str;
	std::cout << "Enter the file name: ";
	std::cin >> str;
	myLoader->LoadMesh(str);
	myLoader->Print_Data();

	std::cout << "---------------Get_Nodes---------------" << std::endl;
	std::cout << myLoader->Get_Nodes() << std::endl;

	std::cout << "---------------Get_Elements---------------" << std::endl;
	std::cout << myLoader->Get_Elements() << std::endl;

	std::cout << "---------------Get_Surfaces---------------" << std::endl;
	std::cout << myLoader->Get_Surfaces() << std::endl;

	std::cout << "---------------Get_Elements_by_ID---------------" << std::endl;
	std::cout << "Enter three nodes: ";
	int id1, id2, id3;
	std::cin >> id1 >> id2 >> id3;
	std::cout << myLoader->Get_Elements_by_ID(id1, id2, id3) << std::endl;

	std::cout << "---------------Get_Elements_by_rib---------------" << std::endl;
	std::cout << "Enter two nodes: ";
	std::cin >> id1 >> id2;
	std::cout << myLoader->Get_Elements_by_rib(id1, id2) << std::endl;

	std::cout << "---------------Get_Borders_by_Border_ID---------------" << std::endl;
	std::cout << "Enter border ID: ";
	std::cin >> id1;
	std::cout << myLoader->Get_Borders_by_Border_ID(id1) << std::endl;

	std::cout << "---------------Get_Nodes_Neighbors---------------" << std::endl;
	std::vector<std::vector<Node>> neighbors;
	myLoader->Get_Nodes_Neighbors();
	for (int i = 1; i < neighbors.size(); ++i) {
		std::cout << "Neighbors for Node with ID = " << i << std::endl << neighbors[i];
	}
	neighbors.clear();

	std::cout << "---------------Print_Data---------------" << std::endl;
	myLoader->Print_Data();

	std::cout << "---------------Insert_New_Nodes---------------" << std::endl;
	myLoader->Insert_New_Nodes();
	std::cout << "STL-container nodes: " << std::endl;
	std::cout << myLoader->Get_Nodes() << std::endl;
	std::cout << "STL-container finite elements: " << std::endl;
	std::cout << myLoader->Get_Elements() << std::endl;
	std::cout << "STL-container boundary finite elements: " << std::endl;
	std::cout << myLoader->Get_Surfaces() << std::endl;

	std::cout << "---------------Protection task---------------" << std::endl;
	Protection_task(*myLoader);

	delete myLoader;
	return 0;
}
