#pragma once
#include <fstream>
#include <vector>
#include <set>
#include "DataTypes.h"

class MeshLoader {
protected:
  std::vector<Node> nodes;
  std::vector<FiniteElement> elements;
  std::vector<BoundaryFiniteElement> boundary;
public:
  virtual void LoadMesh(const std::string&) = 0;
  virtual ~MeshLoader() = default;
  void Print_Data();
  std::vector<Node>& Get_Nodes();
  std::vector<FiniteElement>& Get_Elements();
  std::vector<BoundaryFiniteElement>& Get_Surfaces();
  std::vector<FiniteElement> Get_Elements_by_ID(int, int, int);
  std::vector<FiniteElement> Get_Elements_by_rib(int, int);
  std::vector<FiniteElement> Get_Elements_by_ID_area(int) const;
  std::set <Node> Get_top_nodes_by_border_ID(int) ;
  std::vector<BoundaryFiniteElement> Get_Borders_by_Border_ID(int);
  void Insert_New_Nodes();
  std::vector<std::set<int>> Get_Nodes_Neighbors();
  Node Get_Node_by_ID(int);
};